## asterisk 20.6.0~dfsg+~cs6.13.40431414

=== Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Top level Makefile
#
# Copyright (C) 1999-2010, Digium, Inc.
#
# Mark Spencer <markster@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

# All Makefiles use the following variables:
#
# ASTCFLAGS - compiler options provided by the user (if any)
# _ASTCFLAGS - compiler options provided by the build system
# ASTLDFLAGS - linker flags (not libraries) provided by the user (if any)
# _ASTLDFLAGS - linker flags (not libraries) provided by the build system
# LIBS - additional libraries, at top-level for all links,
#      on a single object just for that object
# SOLINK - linker flags used only for creating dynamically loadable modules
#          as .so files
# DYLINK - linker flags used only for creating shared libraries
#          (.so files on Unix-type platforms, .dylib on Darwin)
#
# Values for ASTCFLAGS and ASTLDFLAGS can be specified in the
# environment when running make, as follows:
#
#	$ ASTCFLAGS="-Werror" make ...
#
# or as a variable value on the make command line itself:
#
#	$ make ASTCFLAGS="-Werror" ...

export ASTTOPDIR		# Top level dir, used in subdirs' Makefiles
export ASTERISKVERSION
export ASTERISKVERSIONNUM

#--- values used for default paths

# DESTDIR is the staging (or final) directory where files are copied
# during the install process. Define it before 'export', otherwise
# export will set it to the empty string making ?= fail.
# Trying to run asterisk from the DESTDIR is completely unsupported
# behavior.
# WARNING: do not put spaces or comments after the value.
DESTDIR?=$(INSTALL_PATH)
export DESTDIR

export INSTALL_PATH       # Additional prefix for the following paths
export ASTCACHEDIR
export ASTETCDIR          # Path for config files
export ASTVARRUNDIR
export ASTSPOOLDIR
export ASTVARLIBDIR
export ASTDATADIR
export ASTDBDIR
export ASTLOGDIR
export ASTLIBDIR
export ASTMODDIR
export ASTMANDIR
export ASTHEADERDIR
export ASTSBINDIR
export AGI_DIR
export ASTCONFPATH
export ASTKEYDIR

export OSARCH             # Operating system

export NOISY_BUILD        # Used in Makefile.rules
export MENUSELECT_CFLAGS  # Options selected in menuselect.
export AST_DEVMODE        # Set to "yes" for additional compiler
                          # and runtime checks
export AST_DEVMODE_STRICT # Enables shadow warnings (-Wshadow)

export _SOLINK            # linker flags for all shared objects
export SOLINK             # linker flags for loadable modules
export DYLINK             # linker flags for shared libraries

#--- paths to various commands
# The makeopts include below tries to set these if they're found during
# configure.
export CC
export CXX
export AR
export RANLIB
export HOST_CC
export BUILD_CC
export INSTALL
export STRIP
export DOWNLOAD
export AWK
export GREP
export MD5
export WGET_EXTRA_ARGS
export LDCONFIG
export LDCONFIG_FLAGS
export PYTHON
export TAR
export PATCH
export SED
export NM
export FIND
export BASENAME
export DIRNAME
export XMLLINT
export XMLSTARLET

# makeopts is required unless the goal is just {dist{-}}clean
ifeq ($(MAKECMDGOALS),clean)
else ifeq ($(MAKECMDGOALS),distclean)
else ifeq ($(MAKECMDGOALS),dist-clean)
else
include makeopts
endif

# start the primary CFLAGS and LDFLAGS with any that were provided
# to the configure script
_ASTCFLAGS:=$(CONFIG_CFLAGS) $(CONFIG_SIGNED_CHAR)
_ASTLDFLAGS:=$(CONFIG_LDFLAGS)

# Some build systems, such as the one in openwrt, like to pass custom target
# CFLAGS and LDFLAGS in the COPTS and LDOPTS variables; these should also
# go before any build-system computed flags, since they are defaults, not
# overrides
_ASTCFLAGS+=$(COPTS)
_ASTLDFLAGS+=$(LDOPTS)

# libxml2 cflags
_ASTCFLAGS+=$(LIBXML2_INCLUDE)

# BIND_8_COMPAT
_ASTCFLAGS+=$(BIND8_CFLAGS)

#Uncomment this to see all build commands instead of 'quiet' output
#NOISY_BUILD=yes

empty:=
space:=$(empty) $(empty)
ASTTOPDIR:=$(subst $(space),\$(space),$(CURDIR))

# Overwrite config files on "make samples" or other config installation targets
OVERWRITE=y

# Include debug and macro symbols in the executables (-g) and profiling info (-pg)
DEBUG=-g3

# Asterisk.conf is located in ASTETCDIR or by using the -C flag
# when starting Asterisk
ASTCONFPATH=$(ASTETCDIR)/asterisk.conf
AGI_DIR=$(ASTDATADIR)/agi-bin

# If you use Apache, you may determine by a grep 'DocumentRoot' of your httpd.conf file
HTTP_DOCSDIR=/var/www/html
# Determine by a grep 'ScriptAlias' of your Apache httpd.conf file
HTTP_CGIDIR=/var/www/cgi-bin

# If your platform's linker expects a prefix on symbols generated from compiling C
# source files, set LINKER_SYMBOL_PREFIX to that value. On some systems, exported symbols
# from C source files are prefixed with '_', for example. If this value is not set
# properly, the linker scripts that live in the '*.exports' files in various places
# in this tree will unintentionally suppress symbols that should be visible
# in the final binary objects.
LINKER_SYMBOL_PREFIX=

# Uncomment this to use the older DSP routines
#_ASTCFLAGS+=-DOLD_DSP_ROUTINES

# Default install directory for DAHDI hooks.
DAHDI_UDEV_HOOK_DIR = /usr/share/dahdi/span_config.d

# If the file .asterisk.makeopts is present in your home directory, you can
# include all of your favorite menuselect options so that every time you download
# a new version of Asterisk, you don't have to run menuselect to set them.
# The file /etc/asterisk.makeopts will also be included but can be overridden
# by the file in your home directory.

ifeq ($(wildcard menuselect.makeopts),)
	USER_MAKEOPTS=$(wildcard ~/.asterisk.makeopts)
	GLOBAL_MAKEOPTS=$(wildcard /etc/asterisk.makeopts)
else
	USER_MAKEOPTS=
	GLOBAL_MAKEOPTS=
endif


MOD_SUBDIR_CFLAGS="-I$(ASTTOPDIR)/include"
OTHER_SUBDIR_CFLAGS="-I$(ASTTOPDIR)/include"

# Create OPTIONS variable, but probably we can assign directly to ASTCFLAGS
OPTIONS=

ifeq ($(findstring -save-temps,$(_ASTCFLAGS) $(ASTCFLAGS)),)
  ifeq ($(findstring -pipe,$(_ASTCFLAGS) $(ASTCFLAGS)),)
    _ASTCFLAGS+=-pipe
  endif
endif

ifeq ($(findstring -Wall,$(_ASTCFLAGS) $(ASTCFLAGS)),)
  _ASTCFLAGS+=-Wall
endif

_ASTCFLAGS+=-Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations $(AST_NESTED_FUNCTIONS) $(AST_CLANG_BLOCKS) $(DEBUG)
ADDL_TARGETS=

ifeq ($(AST_DEVMODE),yes)
  _ASTCFLAGS+=-Werror
  _ASTCFLAGS+=-Wunused
  _ASTCFLAGS+=$(AST_DECLARATION_AFTER_STATEMENT)
  _ASTCFLAGS+=$(AST_TRAMPOLINES)
  _ASTCFLAGS+=-Wundef
  _ASTCFLAGS+=-Wmissing-format-attribute
  _ASTCFLAGS+=-Wformat=2
  ifeq ($(AST_DEVMODE_STRICT),yes)
    _ASTCFLAGS+=-Wshadow
  endif
  ifneq ($(DISABLE_XMLDOC),yes)
    ADDL_TARGETS+=validate-docs
  endif
endif

ifeq ($(OSARCH),NetBSD)
  _ASTCFLAGS+=-isystem /usr/pkg/include
else ifneq ($(findstring BSD,$(OSARCH)),)
  _ASTCFLAGS+=-isystem /usr/local/include
endif

ifeq ($(OSARCH),FreeBSD)
  # -V is understood by BSD Make, not by GNU make.
  BSDVERSION=$(shell make -V OSVERSION -f /usr/share/mk/bsd.port.subdir.mk)
  _ASTCFLAGS+=$(shell if test $(BSDVERSION) -lt 500016 ; then echo "-D_THREAD_SAFE"; fi)
endif

ifeq ($(OSARCH),NetBSD)
  _ASTCFLAGS+=-pthread -D__LIBPTHREAD_SOURCE__ -I/usr/pkg/include
endif

ifeq ($(OSARCH),OpenBSD)
  _ASTCFLAGS+=-pthread -ftrampolines
endif

ifeq ($(OSARCH),linux-uclibc)
  AST_LIBS+=-lpthread -ldl
endif

ifeq ($(OSARCH),SunOS)
  _ASTCFLAGS+=-Wcast-align -DSOLARIS -I../include/solaris-compat -I/opt/ssl/include -I/usr/local/ssl/include -D_XPG4_2 -D__EXTENSIONS__
endif

ifeq ($(GREP),)
else ifeq ($(GREP),:)
else
  ASTERISKVERSION:=$(shell GREP=$(GREP) AWK=$(AWK) GIT=$(GIT) build_tools/make_version .)
endif
ifneq ($(AWK),)
  ifneq ($(wildcard .version),)
    ASTERISKVERSIONNUM:=$(shell $(SED) -e 's/^certified\///' -e 's/-cert/./' .version | $(AWK) -F. '{printf "%01d%02d%02d", $$1, $$2, $$3}')
  endif
endif

ifneq ($(wildcard .svn),)
  ASTERISKVERSIONNUM:=999999
endif

ifneq ($(DISABLE_XMLDOC),yes)
  CORE_XMLDOC=doc/core-en_US.xml
  FULL_XMLDOC=doc/full-en_US.xml
else
  CORE_XMLDOC=
  FULL_XMLDOC=
endif

_ASTCFLAGS+=$(OPTIONS)

MOD_SUBDIRS:=third-party channels pbx apps codecs formats cdr cel bridges funcs tests main res addons $(LOCAL_MOD_SUBDIRS)
OTHER_SUBDIRS:=utils agi contrib
SUBDIRS:=$(OTHER_SUBDIRS) $(MOD_SUBDIRS)
SUBDIRS_INSTALL:=$(SUBDIRS:%=%-install)
SUBDIRS_CLEAN:=$(SUBDIRS:%=%-clean)
SUBDIRS_DIST_CLEAN:=$(SUBDIRS:%=%-dist-clean)
SUBDIRS_UNINSTALL:=$(SUBDIRS:%=%-uninstall)
MOD_SUBDIRS_MENUSELECT_TREE:=$(MOD_SUBDIRS:%=%-menuselect-tree)

ifneq ($(findstring darwin,$(OSARCH)),)
  _ASTCFLAGS+=-D__Darwin__ -mmacosx-version-min=10.6
  _SOLINK=-mmacosx-version-min=10.6 -Wl,-undefined,dynamic_lookup
  _SOLINK+=/usr/lib/bundle1.o
  SOLINK=-bundle $(_SOLINK)
  DYLINK=-Wl,-dylib $(_SOLINK)
  _ASTLDFLAGS+=-L/usr/local/lib
else
# These are used for all but Darwin
  SOLINK=-shared
  DYLINK=$(SOLINK)
  ifeq ($(OSARCH),NetBSD)
    _ASTLDFLAGS+=-L/usr/pkg/lib
  else ifneq ($(findstring BSD,$(OSARCH)),)
    _ASTLDFLAGS+=-L/usr/local/lib
  endif
endif

# Include rpath settings
_ASTLDFLAGS+=$(AST_RPATH)

ifeq ($(OSARCH),SunOS)
  SOLINK=-shared -fpic -L/usr/local/ssl/lib -lrt
  DYLINK=$(SOLINK)
endif

ifeq ($(OSARCH),OpenBSD)
  SOLINK=-shared -fpic
  DYLINK=$(SOLINK)
endif

# comment to print directories during submakes
#PRINT_DIR=yes

ifneq ($(INSIDE_EMACS),)
PRINT_DIR=yes
endif

SILENTMAKE:=$(MAKE) --quiet --no-print-directory
ifneq ($(PRINT_DIR)$(NOISY_BUILD),)
SUBMAKE:=$(MAKE)
else
SUBMAKE:=$(MAKE) --quiet --no-print-directory
endif

mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
mkfile_dir := $(dir $(mkfile_path))

# $(MAKE) is printed in several places, and we want it to be a
# fixed size string. Define a variable whose name has also the
# same size, so we can easily align text.
ifeq ($(MAKE), gmake)
	mK="gmake"
else
	mK=" make"
endif

all: _all
	@echo " +--------- Asterisk Build Complete ---------+"
	@echo " + Asterisk has successfully been built, and +"
	@echo " + can be installed by running:              +"
	@echo " +                                           +"
	@echo " +               $(mK) install               +"
	@echo " +-------------------------------------------+"

full: _full
	@echo " +--------- Asterisk Build Complete ---------+"
	@echo " + Asterisk has successfully been built, and +"
	@echo " + can be installed by running:              +"
	@echo " +                                           +"
	@echo " +               $(mK) install               +"
	@echo " +-------------------------------------------+"


_all: makeopts $(SUBDIRS) $(CORE_XMLDOC) $(ADDL_TARGETS)

_full: makeopts $(SUBDIRS) $(FULL_XMLDOC) $(ADDL_TARGETS)

makeopts: configure
	@echo "****"
	@echo "**** The configure script must be executed before running '$(MAKE)'."
	@echo "****               Please run \"./configure\"."
	@echo "****"
	@exit 1

menuselect.makeopts: menuselect/menuselect menuselect-tree makeopts build_tools/menuselect-deps $(GLOBAL_MAKEOPTS) $(USER_MAKEOPTS)
ifeq ($(filter %.menuselect,$(MAKECMDGOALS)),)
	menuselect/menuselect --check-deps $@
	menuselect/menuselect --check-deps $@ $(GLOBAL_MAKEOPTS) $(USER_MAKEOPTS)
endif

$(MOD_SUBDIRS_MENUSELECT_TREE):
	+@$(SUBMAKE) -C $(@:-menuselect-tree=) SUBDIR=$(@:-menuselect-tree=) moduleinfo
	+@$(SUBMAKE) -C $(@:-menuselect-tree=) SUBDIR=$(@:-menuselect-tree=) makeopts

$(SUBDIRS): makeopts .lastclean main/version.c include/asterisk/build.h defaults.h

ifeq ($(findstring $(OSARCH), mingw32 cygwin ),)
main: third-party
else
    # Windows: we need to build main (i.e. the asterisk dll) first,
    # followed by res, followed by the other directories, because
    # dll symbols must be resolved during linking and not at runtime.
D1:= $(filter-out main,$(MOD_SUBDIRS))
D1:= $(filter-out res,$(D1))

$(D1): res
res:	main
endif

$(MOD_SUBDIRS): makeopts
	+@_ASTCFLAGS="$(MOD_SUBDIR_CFLAGS) $(_ASTCFLAGS)" ASTCFLAGS="$(ASTCFLAGS)" _ASTLDFLAGS="$(_ASTLDFLAGS)" ASTLDFLAGS="$(ASTLDFLAGS)" $(SUBMAKE) --no-builtin-rules -C $@ SUBDIR=$@ all

$(OTHER_SUBDIRS): makeopts

=== channels/Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Makefile for channel drivers
#
# Copyright (C) 1999-2006, Digium, Inc.
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

-include $(ASTTOPDIR)/menuselect.makeopts $(ASTTOPDIR)/menuselect.makedeps

MODULE_PREFIX=chan
MENUSELECT_CATEGORY=CHANNELS
MENUSELECT_DESCRIPTION=Channel Drivers

all: _all

include $(ASTTOPDIR)/Makefile.moddir_rules

ifneq ($(findstring $(OSARCH), mingw32 cygwin ),)
  LIBS+= -lres_monitor.so
endif

$(call MOD_ADD_C,chan_iax2,$(wildcard iax2/*.c))
iax2/parser.o: _ASTCFLAGS+=$(call get_menuselect_cflags,MALLOC_DEBUG)

$(call MOD_ADD_C,chan_sip,$(wildcard sip/*.c))
$(call MOD_ADD_C,chan_pjsip,$(wildcard pjsip/*.c))
$(call MOD_ADD_C,chan_dahdi,$(wildcard dahdi/*.c) sig_analog.c sig_pri.c sig_ss7.c)

chan_dahdi.o: _ASTCFLAGS+=$(call get_menuselect_cflags,LOTS_OF_SPANS)
chan_mgcp.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
chan_unistim.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
chan_phone.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)
chan_sip.o: _ASTCFLAGS+=$(AST_NO_FORMAT_TRUNCATION)

$(call MOD_ADD_C,console_video.c vgrabbers.c console_board.c)

=== sounds/Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Makefile for sound files
#
# Copyright (C) 2006, Digium, Inc.
#
# Kevin P. Fleming <kpfleming@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

.PHONY: dist-clean all uninstall have_download install

-include $(ASTTOPDIR)/menuselect.makeopts $(ASTTOPDIR)/makeopts

CMD_PREFIX?=@
SOUNDS_DIR:=$(DESTDIR)$(ASTDATADIR)/sounds
SOUNDS_CACHE_DIR?=
MOH_DIR:=$(DESTDIR)$(ASTDATADIR)/moh
CORE_SOUNDS_VERSION:=1.6.1
EXTRA_SOUNDS_VERSION:=1.5.2
MOH_VERSION:=2.03
SOUNDS_URL:=https://downloads.asterisk.org/pub/telephony/sounds/releases
MCS:=$(subst -EN-,-en-,$(MENUSELECT_CORE_SOUNDS))
MCS:=$(subst -EN_AU-,-en_AU-,$(MCS))
MCS:=$(subst -EN_GB-,-en_GB-,$(MCS))
MCS:=$(subst -EN_NZ-,-en_NZ-,$(MCS))
MCS:=$(subst -FR-,-fr-,$(MCS))
MCS:=$(subst -ES-,-es-,$(MCS))
MCS:=$(subst -RU-,-ru-,$(MCS))
MCS:=$(subst -IT-,-it-,$(MCS))
MCS:=$(subst -JA-,-ja-,$(MCS))
MCS:=$(subst -SV-,-sv-,$(MCS))
MCS:=$(subst -WAV,-wav,$(MCS))
MCS:=$(subst -ULAW,-ulaw,$(MCS))
MCS:=$(subst -ALAW,-alaw,$(MCS))
MCS:=$(subst -GSM,-gsm,$(MCS))
MCS:=$(subst -G729,-g729,$(MCS))
MCS:=$(subst -G722,-g722,$(MCS))
MCS:=$(subst -SLN16,-sln16,$(MCS))
MCS:=$(subst -SIREN7,-siren7,$(MCS))
MCS:=$(subst -SIREN14,-siren14,$(MCS))
CORE_SOUNDS:=$(MCS:CORE-SOUNDS-%=asterisk-core-sounds-%-$(CORE_SOUNDS_VERSION).tar.gz)
CORE_SOUND_TAGS:=$(MCS:CORE-SOUNDS-%=.asterisk-core-sounds-%-$(CORE_SOUNDS_VERSION))
MES:=$(subst -EN-,-en-,$(MENUSELECT_EXTRA_SOUNDS))
MES:=$(subst -EN_GB-,-en_GB-,$(MES))
MES:=$(subst -FR-,-fr-,$(MES))
MES:=$(subst -WAV,-wav,$(MES))
MES:=$(subst -ULAW,-ulaw,$(MES))
MES:=$(subst -ALAW,-alaw,$(MES))
MES:=$(subst -GSM,-gsm,$(MES))
MES:=$(subst -G729,-g729,$(MES))
MES:=$(subst -G722,-g722,$(MES))
MES:=$(subst -SLN16,-sln16,$(MES))
MES:=$(subst -SIREN7,-siren7,$(MES))
MES:=$(subst -SIREN14,-siren14,$(MES))
EXTRA_SOUNDS:=$(MES:EXTRA-SOUNDS-%=asterisk-extra-sounds-%-$(EXTRA_SOUNDS_VERSION).tar.gz)
EXTRA_SOUND_TAGS:=$(MES:EXTRA-SOUNDS-%=.asterisk-extra-sounds-%-$(EXTRA_SOUNDS_VERSION))
MM:=$(subst -OPSOUND-,-opsound-,$(MENUSELECT_MOH))
MM:=$(subst -WAV,-wav,$(MM))
MM:=$(subst -ULAW,-ulaw,$(MM))
MM:=$(subst -ALAW,-alaw,$(MM))
MM:=$(subst -GSM,-gsm,$(MM))
MM:=$(subst -G729,-g729,$(MM))
MM:=$(subst -G722,-g722,$(MM))
MM:=$(subst -SLN16,-sln16,$(MM))
MM:=$(subst -SIREN7,-siren7,$(MM))
MM:=$(subst -SIREN14,-siren14,$(MM))
MOH:=$(MM:MOH-%=asterisk-moh-%-$(MOH_VERSION).tar.gz)
MOH_TAGS:=$(MM:MOH-%=.asterisk-moh-%-$(MOH_VERSION))
# If "fetch" is used, --continue is not a valid option.
ifneq ($(findstring wget,$(DOWNLOAD)),)
DOWNLOAD+=--continue $(WGET_EXTRA_ARGS)
endif


define sound_format_lang_rule
.PHONY: .asterisk-$(2)$(if $(3),-$(3),)-%

.asterisk-$(2)$(if $(3),-$(3),)-%: asterisk-$(2)$(if $(3),-$(3),)-%.tar.gz
	$(CMD_PREFIX) \
	if test ! -f "$(1)$(if $(3),/$(3),)/$$@"; then \
	  PACKAGE=$$(subst .asterisk,asterisk,$$@).tar.gz; \
	  ( \
	    mkdir -p "$(1)$(if $(3),/$(3),)"; \
	    cd "$(1)$(if $(3),/$(3),)"; \
	    rm -f $$(subst -$(4),,$$@)-*; \
	    cat $$(CURDIR)/$$$${PACKAGE} | gzip -d | tar xof - \
	  ) && touch "$(1)$(if $(3),/$(3),)/$$@"; \
	fi

asterisk-$(2)$(if $(3),-$(3),)-%.tar.gz: have_download
ifneq ($(SOUNDS_CACHE_DIR),)
	$(CMD_PREFIX) \
	if test ! -f "$(1)$(if $(3),/$(3),)/.$$(subst .tar.gz,,$$@)"; then \
	  if test ! -d "$$(SOUNDS_CACHE_DIR)/"; then \
	    mkdir -p "$$(SOUNDS_CACHE_DIR)/"; \
	  fi; \
	  if test ! -f "$$(SOUNDS_CACHE_DIR)/$$@"; then \
	    (cd "$$(SOUNDS_CACHE_DIR)"; $$(DOWNLOAD) $$(SOUNDS_URL)/$$@); \
	  fi; \
	  if test ! -f "$$(SOUNDS_CACHE_DIR)/$$@.sha1"; then \
	    (cd "$$(SOUNDS_CACHE_DIR)"; $$(DOWNLOAD) $$(SOUNDS_URL)/$$@.sha1); \
	  fi; \
	  $$(LN) -sf "$$(SOUNDS_CACHE_DIR)/$$@" .; \
	  $$(LN) -sf "$$(SOUNDS_CACHE_DIR)/$$@.sha1" .; \
	  $$(SHA1SUM) -c --status $$@.sha1 || \
	    ( \
	      rm -f "$$(SOUNDS_CACHE_DIR)/$$@" "$$(SOUNDS_CACHE_DIR)/$$@.sha1" $$@ $$@.sha1; \
	      echo "Bad checksum: $$@" 1>&2; \
	      exit 1; \
	    ) || exit 1; \
	fi
else
	$(CMD_PREFIX) \
	if test ! -f $$@ && test ! -f "$(1)$(if $(3),/$(3),)/.$$(subst .tar.gz,,$$@)"; then \
	  $$(DOWNLOAD) $$(SOUNDS_URL)/$$@; \
	fi
endif
endef # sound_format_lang_rule

all: $(CORE_SOUNDS) $(EXTRA_SOUNDS) $(MOH)

have_download:
	@if test "$(DOWNLOAD)" = ":" ; then \
		echo "**************************************************"; \
		echo "***                                            ***"; \
		echo "*** You must have either wget, curl, or fetch  ***"; \
		echo "*** to be able to automatically download and   ***"; \
		echo "*** install the requested sound packages.      ***"; \
		echo "***                                            ***"; \
		echo "*** Please install one of these, or remove any ***"; \
		echo "*** extra sound package selections in          ***"; \
		echo "*** menuselect before installing Asterisk.     ***"; \
		echo "***                                            ***"; \
		echo "**************************************************"; \
		exit 1; \
	fi

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,en,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,en_AU,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,en_GB,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,en_NZ,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,es,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,fr,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,it,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,ru,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,ja,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),core-sounds,sv,$(CORE_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),extra-sounds,en,$(EXTRA_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),extra-sounds,en_GB,$(EXTRA_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(SOUNDS_DIR),extra-sounds,fr,$(EXTRA_SOUNDS_VERSION)))

$(eval $(call sound_format_lang_rule,$(MOH_DIR),moh,,$(MOH_VERSION)))

dist-clean:
	rm -f *.tar.gz

install: $(CORE_SOUND_TAGS) $(EXTRA_SOUND_TAGS) $(MOH_TAGS)

uninstall:
	rm -rf "$(SOUNDS_DIR)"
	rm -rf "$(MOH_DIR)"

core_sounds_version:
	@echo $(CORE_SOUNDS_VERSION)

extra_sounds_version:
	@echo $(EXTRA_SOUNDS_VERSION)

moh_version:
	@echo $(MOH_VERSION)

=== utils/Makefile ===
#
# Asterisk -- An open source telephony toolkit.
#
# Various utilities
#
# Copyright (C) 1999-2006, Digium
#
# Mark Spencer <markster@digium.com>
#
# This program is free software, distributed under the terms of
# the GNU General Public License
#

ASTTOPDIR?=..
-include $(ASTTOPDIR)/menuselect.makeopts

.PHONY: clean all uninstall

# to get check_expr, add it to the ALL_UTILS list -- this is a somewhat old checking
#     program that wants an ael file for input, and will check each $[] expr for
#     possible (old) problems, like spacing around operators, which dates back to
#     the 1.2 days. The neat part is that it will actually evaluate the expressions.
#     Users could use this to quickly check expressions in their .ael file.
# to get check_expr2, add it to the ALL_UTILS list -- this is a program that will
#     read in a file containing expressions (as if they were in $[ ]), one per line.
#     It will, of course signal any syntax errors. Devs (like murf) should use this whenever
#     changes are made to ast_expr2.y or ast_expr2.fl (or the corresponding .c files),
#     as a regression test. Others (mere mortals?) need not bother, but they are
#     more than welcome to play! The regression test itself is in expr2.testinput.
ALL_UTILS:=$(MENUSELECT_UTILS)
UTILS:=$(ALL_UTILS)

LIBS += $(BKTR_LIB) # astobj2 with devmode uses backtrace

_ASTCFLAGS+=-DSTANDALONE

include $(ASTTOPDIR)/Makefile.rules

ifeq ($(OSARCH),SunOS)
  LIBS+=-lsocket -lnsl
endif

ifeq ($(OSARCH),mingw32)
  UTILS:=
endif

ifneq ($(findstring darwin,$(OSARCH)),)
  AUDIO_LIBS=-framework CoreAudio
endif

ifeq ($(POPT_LIB),)
  UTILS:=$(filter-out smsq,$(UTILS))
endif

ifeq ($(NEWT_LIB),)
  UTILS:=$(filter-out astman,$(UTILS))
endif

ifneq ($(filter pbx_ael,$(MENUSELECT_PBX)),)
  UTILS:=$(filter-out aelparse,$(UTILS))
endif

all: $(UTILS)

install:
	for x in $(UTILS); do \
		if [ "$$x" != "none" ]; then \
			$(INSTALL) -m 755 $$x "$(DESTDIR)$(ASTSBINDIR)/$$x"; \
		fi; \
	done

uninstall:
	for x in $(ALL_UTILS); do rm -f "$(DESTDIR)$(ASTSBINDIR)/$$x"; done

clean:
	rm -f *.o $(ALL_UTILS) check_expr
	rm -f .*.d
	rm -f *.s *.i
	rm -f astmm.c md5.c strcompat.c ast_expr2.c ast_expr2.h ast_expr2f.c pbx_ael.c pval.c hashtab.c lock.c
	rm -f aelparse.c aelbison.c
	rm -f threadstorage.c
	rm -f utils.c strings.c poll.c version.c sha1.c astobj2.c refcounter
	rm -f db1-ast/.*.d
	@$(MAKE) -C db1-ast clean


md5.c: $(ASTTOPDIR)/main/md5.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

astman: astman.o md5.o
astman: LIBS+=$(NEWT_LIB)

stereorize: stereorize.o frame.o
stereorize: LIBS+=-lm

astmm.c: $(ASTTOPDIR)/main/astmm.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

hashtab.c: $(ASTTOPDIR)/main/hashtab.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

lock.c: $(ASTTOPDIR)/main/lock.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

strcompat.c: $(ASTTOPDIR)/main/strcompat.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

pval.c: $(ASTTOPDIR)/res/ael/pval.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

ast_expr2.c: $(ASTTOPDIR)/main/ast_expr2.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

ast_expr2.h: $(ASTTOPDIR)/main/ast_expr2.h
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"

ast_expr2f.c: $(ASTTOPDIR)/main/ast_expr2f.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"
ast_expr2f.o: _ASTCFLAGS+=-I$(ASTTOPDIR)/main -Wno-unused

check_expr: check_expr.o ast_expr2.o ast_expr2f.o strcompat.o threadstorage.o clicompat.o astmm.o

aelbison.c: $(ASTTOPDIR)/res/ael/ael.tab.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"
aelbison.o: _ASTCFLAGS+=-I$(ASTTOPDIR)/res/ael -DYYENABLE_NLS=0

pbx_ael.c: $(ASTTOPDIR)/pbx/pbx_ael.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"
	$(ECHO_PREFIX) echo "   [SED] $@"
	$(CMD_PREFIX) sed 's/ast_debug([[:digit:]][[:digit:]]*/ast_log(LOG_DEBUG/' "$@" > "$@.new"
	$(CMD_PREFIX) mv "$@.new" "$@"

pbx_ael.o: _ASTCFLAGS+=-DAST_MODULE_SELF_SYM=__internal_pbx_ael_self

aelparse.c: $(ASTTOPDIR)/res/ael/ael_lex.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"
	$(ECHO_PREFIX) echo "   [SED] $@"
	$(CMD_PREFIX) sed 's/ast_debug([[:digit:]][[:digit:]]*/ast_log(LOG_DEBUG/' "$@" > "$@.new"
	$(CMD_PREFIX) mv "$@.new" "$@"

aelparse.o: _ASTCFLAGS+=-I$(ASTTOPDIR)/res -Wno-unused $(AST_NO_FORMAT_TRUNCATION)
aelparse: LIBS+=-lm $(AST_CLANG_BLOCKS_LIBS)
aelparse: aelparse.o aelbison.o pbx_ael.o hashtab.o lock.o ael_main.o ast_expr2f.o ast_expr2.o strcompat.o pval.o extconf.o astmm.o

threadstorage.c: $(ASTTOPDIR)/main/threadstorage.c
	$(ECHO_PREFIX) echo "   [CP] $(subst $(ASTTOPDIR)/,,$<) -> $@"
	$(CMD_PREFIX) cp "$<" "$@"


extconf.o: _ASTCFLAGS+=$(call get_menuselect_cflags,DETECT_DEADLOCKS)
extconf.o: extconf.c

check_expr2: $(ASTTOPDIR)/main/ast_expr2f.c $(ASTTOPDIR)/main/ast_expr2.c $(ASTTOPDIR)/main/ast_expr2.h astmm.o
	$(ECHO_PREFIX) echo "   [CC] ast_expr2f.c -> ast_expr2fz.o"
	$(CC) -g -c -I$(ASTTOPDIR)/include $(_ASTCFLAGS) -DYY_NO_INPUT $(ASTTOPDIR)/main/ast_expr2f.c -o ast_expr2fz.o
	$(ECHO_PREFIX) echo "   [CC] ast_expr2.c -> ast_expr2z.o"
	$(CC) -g -c -I$(ASTTOPDIR)/include $(_ASTCFLAGS) -DSTANDALONE2 $(ASTTOPDIR)/main/ast_expr2.c -o ast_expr2z.o
	$(ECHO_PREFIX) echo "   [LD] ast_expr2fz.o ast_expr2z.o  -> check_expr2"
	$(CC) -g -o check_expr2 ast_expr2fz.o ast_expr2z.o astmm.o -lm $(_ASTLDFLAGS)
	$(ECHO_PREFIX) echo "   [RM] ast_expr2fz.o ast_expr2z.o"
	rm ast_expr2z.o ast_expr2fz.o
ifneq ($(CROSS_COMPILING),1)
	./check_expr2 expr2.testinput
endif

smsq: smsq.o strcompat.o
smsq: LIBS+=$(POPT_LIB)

streamplayer: streamplayer.o

CHECK_SUBDIR:	# do nothing, just make sure that we recurse in the subdir/
db1-ast/libdb1.a: CHECK_SUBDIR
	_ASTCFLAGS="$(_ASTCFLAGS) -Wno-strict-aliasing" ASTCFLAGS="$(ASTCFLAGS)" $(MAKE) -C db1-ast libdb1.a

astdb2sqlite3: LIBS+=$(SQLITE3_LIB)
astdb2sqlite3: _ASTCFLAGS+=$(SQLITE3_INCLUDE)
astdb2sqlite3: db1-ast/libdb1.a

astdb2bdb: LIBS+=$(SQLITE3_LIB)
astdb2bdb: _ASTCFLAGS+=$(SQLITE3_INCLUDE)
astdb2bdb: db1-ast/libdb1.a

conf_bridge_binaural_hrir_importer: LIBS+=$(SNDFILE_LIB)
conf_bridge_binaural_hrir_importer.o: _ASTCFLAGS+=$(SNDFILE_INCLUDE)

ifneq ($(wildcard .*.d),)
   include .*.d
endif

=== third-party/pjproject/Makefile ===
.PHONY: _all all _install install clean distclean echo_cflags configure

.NOTPARALLEL:

include ../versions.mak

export PJDIR := $(shell pwd -P)/source

SPECIAL_TARGETS :=

ifneq ($(findstring configure,$(MAKECMDGOALS))$(findstring echo_cflags,$(MAKECMDGOALS)),)
# Run from $(ASTTOPDIR)/configure
    SPECIAL_TARGETS += configure
endif

ifeq ($(findstring echo_cflags,$(MAKECMDGOALS)),echo_cflags)
    -include build.mak
    ECHO_PREFIX=@\#
endif

ifeq ($(findstring clean,$(MAKECMDGOALS)),clean)
# clean or distclean
    SPECIAL_TARGETS += clean
endif

ifeq ($(findstring uninstall,$(MAKECMDGOALS)),uninstall)
    SPECIAL_TARGETS += uninstall
endif


ifneq ($(wildcard ../../makeopts),)
    include ../../makeopts
endif

TARGETS = build.mak

ifeq ($(SPECIAL_TARGETS),)
# Run locally or from $(ASTTOPDIR)/Makefile.  All include files should be present
    ifeq ($(wildcard ../../makeopts),)
        $(error ASTTOPDIR/configure hasn't been run)
    endif

    ifeq ($(PJPROJECT_BUNDLED),yes)
        all: _all
        install: _install

        ifneq ($(wildcard ../../menuselect.makeopts),)
            include ../../menuselect.makeopts
        else
            $(warning ASTTOPDIR/menuselect hasn't been run yet.  Can't find debug options.)
        endif
		include ../../Makefile.rules
        include ../Makefile.rules
		include Makefile.rules

        -include source/user.mak
        -include source/version.mak
        -include source/build.mak
        CF := $(filter-out -W%,$(CC_CFLAGS))
        CF := $(filter-out -I%,$(CF))
        ifeq ($(AST_DEVMODE),yes)
            apps := source/pjsip-apps/bin/pjsua-$(TARGET_NAME) source/pjsip-apps/bin/pjsystest-$(TARGET_NAME)
            TARGETS += $(apps)
            ifneq ($(PYTHONDEV_LIB),)
                TARGETS += source/pjsip-apps/src/python/_pjsua.so
            endif
            CF += -DPJPROJECT_BUNDLED_ASSERTIONS=yes
        endif
        MALLOC_DEBUG_LIBS = source/pjsip-apps/lib/libasterisk_malloc_debug.a
        ifneq ($(findstring darwin,$(OSARCH)),)
            MALLOC_DEBUG_LDFLAGS = -L$(PJDIR)/pjsip-apps/lib -Wl,-all_load -lasterisk_malloc_debug -Wl,-noall_load
        else
             # These are used for all but Darwin
            MALLOC_DEBUG_LDFLAGS = -L$(PJDIR)/pjsip-apps/lib -Wl,-whole-archive -lasterisk_malloc_debug -Wl,-no-whole-archive
        endif
        ifeq ($(findstring DONT_OPTIMIZE,$(MENUSELECT_CFLAGS)),)
            CF += -O3
        endif
        export CFLAGS += $(CF) -g3
        export LDFLAGS += $(CC_LDFLAGS)
        TARGETS += pjproject.symbols
    else
        all install:
    endif
else
	include ../../Makefile.rules
	include ../Makefile.rules
	include Makefile.rules
endif

export PJ_CFLAGS := $(filter-out -O% -g%,$(PJ_CFLAGS))
export CFLAGS += $(CF) $(OPENSSL_INCLUDE)
export LDFLAGS += $(CC_LDFLAGS) $(OPENSSL_LIB)

ECHO_PREFIX := $(ECHO_PREFIX) echo '[pjproject] '
ECHO_PREFIX_NONL := $(ECHO_PREFIX) echo -n '[pjproject] '
SHELL_ECHO_PREFIX := echo '[pjproject] '

_all: $(TARGETS)

$(DOWNLOAD_DIR)/$(TARBALL_FILE): ../versions.mak
	$(CMD_PREFIX) ($(TARBALL_EXISTS) && $(TARBALL_VERIFY) && touch $@) || (rm -rf $@ ;\
	$(TARBALL_DOWNLOAD)) || (rm -rf $@ ;\
	$(SHELL_ECHO_PREFIX) Retrying download ; $(TARBALL_DOWNLOAD))

source/.unpacked: $(DOWNLOAD_DIR)/$(TARBALL_FILE)
	$(CMD_PREFIX) \
		$(TARBALL_VERIFY) || (rm -rf $@ ; $(SHELL_ECHO_PREFIX) Retrying download ; $(TARBALL_DOWNLOAD)) ;\
		$(SHELL_ECHO_PREFIX) Unpacking $< ;\
		rm -rf source pjproject-*/ $(REALLY_QUIET) || : ;\
		$(TAR) -xjf $< ;\
		mv pjproject-$(PJPROJECT_VERSION) source
	$(ECHO_PREFIX) Applying patches "$(realpath patches)" "$(realpath .)/source"
	$(CMD_PREFIX) ../apply_patches $(QUIET_CONFIGURE) "$(realpath patches)" "$(realpath .)/source"
	-@touch source/.unpacked

source/user.mak: $(if $(PJPROJECT_BUNDLED_OOT),,source/.unpacked) patches/user.mak
	$(ECHO_PREFIX) Applying user.mak
	$(CMD_PREFIX) cp -f patches/user.mak source/

source/pjlib/include/pj/%.h: patches/%.h
	$(ECHO_PREFIX) Applying custom include file $<
	$(CMD_PREFIX) cp -f $< source/pjlib/include/pj/

.rebuild_needed: $(wildcard ../../.lastclean)
	$(ECHO_PREFIX) Rebuilding
	$(CMD_PREFIX) $(MAKE) clean $(REALLY_QUIET)

source/build.mak: Makefile.rules source/user.mak $(if $(PJPROJECT_BUNDLED_OOT),,.rebuild_needed) $(subst patches,source/pjlib/include/pj,$(wildcard patches/*.h))
	$(ECHO_PREFIX) Configuring with $(PJPROJECT_CONFIG_OPTS) 
	$(CMD_PREFIX) (cd source ; ./aconfigure $(QUIET_CONFIGURE) $(PJPROJECT_CONFIG_OPTS))

build.mak: source/build.mak
	$(CMD_PREFIX) $(GREP) -v -e prefix -e "export PJ_SHARED_LIBRARIES" -e MACHINE_NAME \
		-e OS_NAME -e HOST_NAME -e CC_NAME -e CROSS_COMPILE -e LINUX_POLL $< > $@

configure: source/build.mak

# We need to filter-out any -O and -g options in PJ_CFLAGS before echoing out
# the result so Asterisk modules don't have the optimization and symbolic debug
# options overridden by the PJPROJECT configure script selected settings.
echo_cflags: source/build.mak
	@echo $(filter-out -O% -g%,$(PJ_CFLAGS))

# The dependency_utils script needs TARGET_NAME in the environment
export TARGET_NAME

# PJ_LIB_FILES is set by the pjproject build.mak and contains the libs we
# need, but not in the order they need to be built.  We need to compile
# pjlib, then pjlib-util, then the rest so we separate them out and create
# the dependencies.  First though, we shorten all file paths by making them
# relative to the current directory.
SHORTENED_PJ_LIB_FILES = $(subst $(CURDIR)/,,$(PJ_LIB_FILES))
# Now separate them
PJLIB_LIB_FILES = $(filter %/libpj-$(TARGET_NAME).a,$(SHORTENED_PJ_LIB_FILES))
PJLIB_UTIL_LIB_FILES = $(filter %/libpjlib-util-$(TARGET_NAME).a,$(SHORTENED_PJ_LIB_FILES))
RESAMPLE_LIB_FILE = $(filter %/libresample-$(TARGET_NAME).a,$(SHORTENED_PJ_LIB_FILES))
# The rest.
PJSIP_LIB_FILES = $(filter-out $(PJLIB_LIB_FILES) $(PJLIB_UTIL_LIB_FILES) $(RESAMPLE_LIB_FILE),$(SHORTENED_PJ_LIB_FILES))

# Create the dependency order we need
$(PJLIB_UTIL_LIB_FILES): $(PJLIB_LIB_FILES)
$(PJSIP_LIB_FILES): $(PJLIB_UTIL_LIB_FILES)

# and here's the full list
ALL_LIB_FILES = $(PJLIB_LIB_FILES) $(PJLIB_UTIL_LIB_FILES) $(PJSIP_LIB_FILES) $(RESAMPLE_LIB_FILE)

# Assuming that since you're doing an out-of-tree build you're modifying
# the pjproject source files, we need to create dependencies between
# the libraries and their respective source files.  Pjproject does
# create dependency files if you run 'make dep' but those files include
# the system include files and the paths are relative to the lib's
# "build" directory.  Neither really works for us.
# So...
# We create our own "astdep" files with dependency paths relative
# to "this" directory and strip out all the system includes.
# The dependency_utils script does all the heavy lifting.
#
# REMINDER: None of this gets invoked unless you're doing an out-of-tree
# pjproject build.

ifdef PJPROJECT_BUNDLED_OOT
    ALL_PJDEP_FILES = $(shell TARGET_NAME=$(TARGET_NAME) ./dependency_utils getpjdepname $(ALL_LIB_FILES))
    ALL_ASTDEP_FILES = $(ALL_PJDEP_FILES:.depend=.astdep)

    $(ALL_PJDEP_FILES): build.mak
		$(ECHO_PREFIX) Generating pjproject dependency file $(@F)
		$(CMD_PREFIX) $(MAKE) -C $(@D) dep $(REALLY_QUIET)

    $(ALL_ASTDEP_FILES): %.astdep: %.depend
		$(ECHO_PREFIX) Generating asterisk dependency file $(@F)
		$(CMD_PREFIX) ./dependency_utils gendepfile $<
    ifeq ($(SPECIAL_TARGETS),)
        ifneq ($(ALL_ASTDEP_FILES),)
            include $(ALL_ASTDEP_FILES)
            depends: $(ALL_ASTDEP_FILES)
        endif
    endif
endif

# resample's a little odd in that it's build directory is one directory
# level down from the other libraries.  We set the RESAMPLE_OPTS
# variable for it then let the ALL_LIB_FILE build rules take over.
$(RESAMPLE_LIB_FILE): RESAMPLE_OPTS=/resample all

.PRECIOUS: $(ALL_LIB_FILES)

$(ALL_LIB_FILES): BUILD_DIR=$(dir $(@D))
$(ALL_LIB_FILES): source/build.mak source/pjlib/include/pj/config_site.h
	$(ECHO_PREFIX) Compiling $(@F)
	$(CMD_PREFIX) ( $(MAKE) -C $(BUILD_DIR)build$(if $(RESAMPLE_OPTS),$(RESAMPLE_OPTS), $(@F)) >/dev/null ) $(if $(PJPROJECT_BUNDLED_OOT),2>&1 | ($(GREP) -E -v "^(r - output|ar:)" || : ),$(REALLY_QUIET))

pjproject.symbols: $(ALL_LIB_FILES)
	$(ECHO_PREFIX) Generating symbols
	$(CMD_PREFIX) $(NM) -Pog $(ALL_LIB_FILES) | $(SED) -n -E -e "s/.+: ([_]?[pP][jJ][^ ]+) .+/\1/gp" | sort -u > pjproject.symbols

source/pjsip-apps/src/asterisk_malloc_debug.c: patches/asterisk_malloc_debug.c
	$(ECHO_PREFIX) Copying $< to $@
	$(CMD_PREFIX) cp -f $< $@
	-$(CMD_PREFIX) mkdir source/pjsip-apps/lib/ $(REALLY_QUIET)

source/pjsip-apps/lib/asterisk_malloc_debug.o: source/pjsip-apps/src/asterisk_malloc_debug.c | source/pjlib/include/pj/config_site.h source/pjlib/include/pj/asterisk_malloc_debug.h
	$(ECHO_PREFIX) Compiling asterisk debug malloc stubs
	$(CMD_PREFIX) $(CC) -fPIC  $(PJ_CFLAGS) -c $< -o $@

source/pjsip-apps/lib/libasterisk_malloc_debug.a: source/pjsip-apps/lib/asterisk_malloc_debug.o
	$(ECHO_PREFIX) Creating archive $(@F)
	$(CMD_PREFIX) ar qs $@ $< $(REALLY_QUIET)

$(apps): APP = $(filter pj%,$(subst -, ,$(notdir $@)))
$(apps): LDFLAGS += $(MALLOC_DEBUG_LDFLAGS)
$(apps): $(MALLOC_DEBUG_LIBS) pjproject.symbols
	$(ECHO_PREFIX) Compiling $(APP)
	$(CMD_PREFIX) +$(MAKE) -C source/pjsip-apps/build $(APP) $(REALLY_QUIET)
	$(CMD_PREFIX) touch $@

source/pjsip-apps/src/python/_pjsua.o: source/pjsip-apps/src/python/_pjsua.c $(apps)
	$(ECHO_PREFIX) Compiling python bindings
	$(CMD_PREFIX) $(CC) -o $@ -c $< $(PYTHONDEV_INCLUDE) $(CFLAGS) $(PJ_CFLAGS)

source/pjsip-apps/src/python/_pjsua.so: LDFLAGS += $(MALLOC_DEBUG_LDFLAGS)
source/pjsip-apps/src/python/_pjsua.so: source/pjsip-apps/src/python/_pjsua.o
	$(ECHO_PREFIX) Linking python bindings $(@F)
	$(CMD_PREFIX) $(CC) -shared -pthread -o $@ $< $(LDFLAGS) $(PJ_LDFLAGS) $(APP_LDLIBS) $(PYTHONDEV_LIB) $(REALLY_QUIET)

_install: _all
	@if [ ! -d "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject" ]; then \
		$(INSTALL) -d "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject"; \
	fi;
ifneq ($(findstring source/pjsip-apps/bin/pjsua-$(TARGET_NAME),$(TARGETS)),)
	$(ECHO_PREFIX) Installing apps
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/bin/pjsua-$(TARGET_NAME) "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/pjsua"
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/bin/pjsystest-$(TARGET_NAME) "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/pjsystest"
endif
ifneq ($(findstring _pjsua.so,$(TARGETS)),)
	$(ECHO_PREFIX) Installing python bindings
	$(CMD_PREFIX) $(INSTALL) -m 755 source/pjsip-apps/src/python/_pjsua.so "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/"
	$(CMD_PREFIX) $(INSTALL) -m 644 source/pjsip-apps/src/python/pjsua.py "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject/"
endif

all: _all

uninstall:
	$(ECHO_PREFIX) Uninstalling apps and python bindings
	$(CMD_PREFIX) rm -rf "$(DESTDIR)$(ASTDATADIR)/third-party/pjproject"

clean:
	$(ECHO_PREFIX) Cleaning
	+-$(CMD_PREFIX) {\
		if [ -d source ] ; then  \
			$(SUBMAKE) -C source clean ;\
			rm -rf source/pjsip-apps/bin/* ;\
			$(FIND) source/ '(' -name *.a -or -name *.o -or -name *.so ')' -delete ;\
		fi ;\
		rm -rf pjproject.symbols ;\
		} $(REALLY_QUIET) || :

distclean: clean
	$(ECHO_PREFIX) Distcleaning
	+-$(CMD_PREFIX) {\
		rm -rf build.mak .rebuild_needed ;\
		if [ "x$(PJPROJECT_BUNDLED_OOT)" = "x" -a ! -d source/.git ] ; then \
			rm -rf source pjproject-*.tar.bz2 ;\
		else \
			$(SUBMAKE) -C source distclean ;\
			rm -rf source/build.mak source/user.mak ;\
			$(FIND) source/ -name '*asterisk_malloc_debug*' -delete ;\
			$(FIND) source/ '(' -name '.*.depend' -or -name '.*.astdep' ')' -delete ;\
		fi \
		} $(REALLY_QUIET) || :

=== debian/changelog ===
asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2build5) noble; urgency=medium

  * No-change rebuild against libssl3t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 01:13:12 +0100

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:19:29 +0000

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2build3) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:05:28 +0000

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:01:43 +0000

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:23:20 +0000

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-2) unstable; urgency=medium

  * update patch 2016 to avoid excessive logging;
    closes: bug#1060275, thanks to Daniel

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 30 Jan 2024 11:42:08 +0100

asterisk (1:20.6.0~dfsg+~cs6.13.40431414-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * unfuzz patches
  * update copyright info: update coverage
  * build-depend on libjwt-dev

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 26 Jan 2024 14:53:47 +0100

asterisk (1:20.5.2~dfsg+~cs6.13.40431414-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * use systemd.pc to place systemd service unit;
    build-depend on systemd-dev;
    closes: bug#1059180, thanks to Chris Hofstaedtler

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 22 Dec 2023 13:58:28 +0100

asterisk (1:20.5.1~dfsg+~cs6.13.40431414-1) unstable; urgency=high

  [ upstream ]
  * new release
    + fixes these upstream bugs:
      CVE-2023-49294 CVE-2023-49786;
      closes: bug#1059032, #1059033, thanks to Salvatore Bonaccorso

  [ Jonas Smedegaard ]
  * fix enable opus codec;
    build-depend on libopusenc-dev;
    closes: bug#1025165,
    thanks to Paweł Bogusławski, Faidon Liambotis and Athos Ribeiro
  * set urgency=high due to multiple security bugfixes

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Dec 2023 17:38:11 +0100

asterisk (1:20.5.0~dfsg+~cs6.13.40431414-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 25 Nov 2023 12:25:03 +0100

=== debian/control ===
Source: asterisk
Priority: optional
Section: comm
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Bernhard Schmidt <berni@debian.org>,
 Jeremy Lainé <jeremy.laine@m4x.org>,
 Jonas Smedegaard <dr@jones.dk>,
 Mark Purcell <msp@debian.org>,
 Tzafrir Cohen <tzafrir@debian.org>,
Build-Depends:
 autoconf,
 automake,
 binutils-dev,
 cmark-gfm <!nodoc>,
 dahdi-source,
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 freetds-dev,
 libasound2-dev,
 libavcodec-dev,
 libavdevice-dev,
 libbluetooth-dev [linux-any],
 libc-client2007e-dev,
 libcap-dev [linux-any],
 libcodec2-dev,
 libcurl4-openssl-dev,
 libedit-dev,
 libfftw3-dev,
 libgmime-3.0-dev,
 libgsm1-dev,
 libical-dev,
 libiksemel-dev,
 libjack-dev,
 libjansson-dev,
 libjwt-dev,
 libldap-dev,
 liblua5.1-dev,
 libncurses-dev,
 libneon27-dev,
 libnewt-dev,
 libogg-dev,
 libopencore-amrnb-dev,
 libopencore-amrwb-dev,
 libopenr2-dev [linux-any],
 libopus-dev,
 libopusenc-dev,
 libopusfile-dev,
 libpopt-dev,
 libpq-dev,
 libpri-dev,
 libradcli-dev,
 libreadline-dev,
 libresample1-dev,
 libsdl-image1.2-dev,
 libsndfile1-dev,
 libsnmp-dev,
 libspandsp-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libsrtp2-dev,
 libss7-dev,
 libssl-dev,
 libswscale-dev,
 libsystemd-dev [linux-any],
 libtonezone-dev [linux-any],
 libunbound-dev,
 liburiparser-dev,
 libvo-amrwbenc-dev,
 libvorbis-dev,
 libxml2-dev,
 libxslt1-dev,
 perl <!nodoc>,
 portaudio19-dev,
 systemd-dev,
 unixodbc-dev,
 uuid-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Homepage: https://www.asterisk.org/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/asterisk.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/asterisk
Rules-Requires-Root: no

Package: asterisk
Architecture: any
Depends:
 adduser,
 asterisk-config (= ${source:Version}) | asterisk-config-custom,
 asterisk-core-sounds-en,
 asterisk-modules (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Provides:
 asterisk-abi-${asterisk:ABI},
Recommends:
 asterisk-moh-opsound-gsm,
 sox,
Suggests:
 asterisk-dahdi,
 asterisk-dev,
 asterisk-doc,
 asterisk-ooh323,
 asterisk-opus,
Description: Open Source Private Branch Exchange (PBX)
 Asterisk is an Open Source PBX and telephony toolkit.
 It is, in a sense, middleware
 between Internet and telephony channels on the bottom,
 and Internet and telephony applications at the top.
 .
 Asterisk can be used with Voice over IP standards
 (SIP, H.323, IAX and more),
 or the Public Switched Telephone Network (PSTN)
 through supported hardware.
 .
 Supported hardware:
 .
  * All Wildcard (tm) ISDN PRI cards from Digium
  * HFC-S/HFC-4S-based ISDN BRI cards
    (Junghanns.NET, beroNet, Digium etc.)
  * All TDM (FXO/FXS) cards from Digium
  * Various clones of Digium cards such as those by OpenVox
  * Xorcom Astribank USB telephony adapter
  * Voicetronix OpenPCI, OpenLine and OpenSwitch cards
  * CAPI-compatible ISDN cards
    (using the add-on package chan-capi)
  * Full Duplex Sound Card (ALSA or OSS) supported by Linux
  * Tormenta T1/E1 card
  * QuickNet Internet PhoneJack and LineJack
 .
 This is the main package
 that includes the Asterisk daemon
 and most channel drivers and applications.

Package: asterisk-modules
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 asterisk-opus (<< 13.7+20171009-2+),
 asterisk-voicemail (<< 1:18),
 asterisk-voicemail-imapstorage (<< 1:18),
 asterisk-voicemail-odbcstorage (<< 1:18),
Breaks:
 asterisk-opus (<< 13.7+20171009-2+),
 asterisk-voicemail (<< 1:18),
 asterisk-voicemail-imapstorage (<< 1:18),
 asterisk-voicemail-odbcstorage (<< 1:18),
Section: libs
Description: loadable modules for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes most of the Asterisk loadable modules.
 There is normally no need to explicitly install it.

Package: asterisk-dahdi
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 dahdi,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 asterisk-modules (<< 1:11.6.0~dfsg-2),
Replaces:
 asterisk-modules (<< 1:11.6.0~dfsg-2),
Description: DAHDI devices support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package includes the DAHDI channel driver (chan_dahdi.so)
 and a number of other Asterisk modules that require DAHDI support.
 They will not be useful without kernel-level DAHDI support.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-ooh323
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: H.323 protocol support for the Asterisk PBX - ooH323c
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This channel driver (chan_ooh323c) provides support
 for the H.323 protocol for Asterisk.
 This is an independent implementation
 that does not depend on OpenH323,
 but may be less functional than the original chan_h323.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mp3
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: MP3 playback support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support
 for playing MP3-encoded files in Asterisk.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mysql
Architecture: any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: MySQL database protocol support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support for using a MySQL database
 to store configuration, call detail records,
 and also provides generic access to it from the dialplan.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-mobile
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Bluetooth phone support for the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides support
 for connecting Bluetooth devices to the Asterisk PBX.
 It allows you to:
   * Send and receive PSTN calls and SMS messages
     over a Bluetooth phone.
   * Use a Bluetooth handset as a local phone
     connected to your PBX.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-tests
Architecture: linux-any
Depends:
 asterisk (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: internal test modules of the Asterisk PBX
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package provides modules
 that run various functionality tests.
 You would normally not install this package
 unless you test a build of Asterisk.
 .
 For more information about the Asterisk PBX,
 have a look at the Asterisk package.

Package: asterisk-doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 asterisk,
Section: doc
Description: Source code documentation for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the documentation
 for configuring an Asterisk system.

Package: asterisk-dev
Architecture: all
Multi-Arch: foreign
Depends:
 debhelper,
 perl:any,
 ${misc:Depends},
Recommends:
 asterisk,
Provides:
 dh-sequence-asterisk,
Section: devel
Description: Development files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the include files
 used if you wish to compile a package
 which requires Asterisk's source file headers.

Package: asterisk-config
Depends:
 ${misc:Depends},
Recommends:
 asterisk,
Conflicts:
 asterisk-config-custom,
Replaces:
 asterisk-config-custom,
Architecture: all
Description: Configuration files for Asterisk
 Asterisk is an Open Source PBX and telephony toolkit.
 .
 This package contains the default configuration files of Asterisk.
 .
 With program asterisk-config-custom in the asterisk package,
 you can create an asterisk-config replacement package.

=== debian/rules ===
#!/usr/bin/make -f

# resolve DEB_VERSION_UPSTREAM DEB_VERSION_UPSTREAM_REVISION DEB_DISTRIBUTION
include /usr/share/dpkg/pkg-info.mk

# resolve DEB_BUILD_ARCH_OS DEB_HOST_MULTIARCH
include /usr/share/dpkg/architecture.mk

# generate documentation unless nodoc requested
CHANGELOGS_stem = ChangeLogs/ChangeLog-$(firstword $(subst ~, ,$(DEB_VERSION_UPSTREAM)))
DOCS_stem = README SECURITY
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CHANGELOGS = $(CHANGELOGS_stem:=.html) $(CHANGELOGS_stem:=.txt)
DOCS = $(DOCS_stem:=.html) $(DOCS_stem:=.txt)
MANPAGES = debian/build/dh_asterisk.1
endif

# enable hardening compiler options
# see <https://wiki.debian.org/Hardening#Using_Hardening_Options>
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# revive upstream optimization flags unless DEB_BUILD_OPTIONS=noopt
# code allegedly fails partial-inlining optimization with GCC >= 8.2.1,
# see <Makefile.rules> and upstream git commit 449dff9
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
DEB_CFLAGS_MAINT_STRIP = -O2
DEB_CFLAGS_MAINT_APPEND = -O3 -fno-partial-inlining
endif
include /usr/share/dpkg/buildflags.mk

# Pass CPPFLAGS in the CFLAGS as otherwise the build system will
# ignore them.
CFLAGS += $(CPPFLAGS)

LDFLAGS += -Wl,--as-needed

# Sanity check for a stable release:
SAVED_ABI_HASH = 1fb7f5c06d7a2052e38d021b3d8ca151

# resolve PJPROJECT version
PJMAJ = $(shell grep -Po '^export PJ_VERSION_MAJOR\s+:=\s+\K\d+' Xpjproject/version.mak)
PJMIN = $(shell grep -Po '^export PJ_VERSION_MINOR\s+:=\s+\K\d+' Xpjproject/version.mak)
PJREV = $(shell grep -Po '^export PJ_VERSION_REV\s+:=\s+\K\d+' Xpjproject/version.mak)
PJVER := $(PJMAJ)$(if $(PJMIN),.$(PJMIN)$(if $(PJREV),.$(PJREV)))

PJDIR = debian/build-pjproject

# don't let asterisk mess with build flags
BUILDFLAGS += AST_FORTIFY_SOURCE= DEBUG= OPTIMIZE=

# show full gcc arguments unless DEB_BUILD_OPTIONS=terse
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
BUILDFLAGS += NOISY_BUILD=yes
endif

BUILDFLAGS += ASTDATADIR=/usr/share/asterisk ASTVARRUNDIR=/var/run/asterisk

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ADDONS_ENABLE = app_macro app_voicemail_imap app_voicemail_odbc
ADDONS_ENABLE += res_config_mysql
ADDONS_ENABLE += chan_mobile chan_ooh323 chan_sip
ADDONS_ENABLE += codec_opus_open_source
ADDONS_ENABLE += aelparse format_mp3 smsq TEST_FRAMEWORK
ADDONS_DISABLE = BUILD_NATIVE
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
ADDONS_ENABLE += BETTER_BACKTRACES DEBUG_THREADS
endif

# make sure we have 'fetch' . We need to have either wget or fetch
# on the system. However it is generally not a good idea to actually
# get remote tarballs at build time. So if neither wget nor fetch
# happen to be installed, the configure script will find a dummy
# fetch script that always returns an error.
FETCH_ENV = PATH=$$PATH:$(CURDIR)/debian/dummyprogs

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

export deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@

%.html: %.md
	cmark-gfm $< > $@

%.txt: %.md
	cmark-gfm --to plaintext $< > $@

override_dh_autoreconf:
	if [ ! -r configure.debian_sav ]; then cp -a configure configure.debian_sav; fi
	[ -f .version.debian_sav ] || cp -a .version .version.debian_sav
	echo $(DEB_VERSION_UPSTREAM_REVISION) > .version
	dh_autoreconf -- ./bootstrap.sh

execute_before_dh_auto_configure:
	chmod 755 debian/dummyprogs/fetch
	# create DSFG-free version of pjproject source
	# as upstream build expects it
	mkdir --parents $(PJDIR)
	rm -f $(PJDIR)/pjproject-${PJVER}
	ln --symbolic ../../Xpjproject $(PJDIR)/pjproject-${PJVER}
	( cd $(PJDIR) && tar --create pjproject-${PJVER}/* ) \
		| bzip2 --fast > $(PJDIR)/pjproject-${PJVER}.tar.bz2
	cp third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5 third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav
	( cd $(PJDIR) && md5sum pjproject-${PJVER}.tar.bz2 ) > third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5

	cp --force --recursive --target-directory=. Xamr/codecs Xamr/include Xamr/res

	rm --force --recursive addons/mp3
	mkdir addons/mp3
	cp --force --target-directory=addons/mp3 Xmp3/*

	cp --force --recursive --target-directory=. Xopus/codecs Xopus/formats

override_dh_auto_configure:
	TMPDIR="$(CURDIR)/$(PJDIR)" $(FETCH_ENV) dh_auto_configure -- \
		--disable-asteriskssl \
		--with-gsm \
		--with-imap=system \
		--without-pwlib \
		$(if $(EXP_RELEASE),,--without-sdl) \
		$(if $(findstring debug,$(DEB_BUILD_OPTIONS)),--enable-dev-mode) \
		|| { cat config.log; exit 1; }

#		--with-cap \

execute_before_dh_auto_build:
	$(MAKE) menuselect.makeopts BUILD_CFLAGS="$(CFLAGS)" BUILD_LDFLAGS="$(LDFLAGS)"
	for module in $(ADDONS_ENABLE); do menuselect/menuselect --enable $$module menuselect.makeopts; done
	for module in $(ADDONS_DISABLE); do menuselect/menuselect --disable $$module menuselect.makeopts; done

override_dh_auto_build:
	$(FETCH_ENV) dh_auto_build -- $(BUILDFLAGS)

execute_after_dh_auto_build: $(DOCS) $(CHANGELOGS) $(MANPAGES)
	# Sanity check: don't break the ABI for modules:
	@abi_hash=$$(awk -F'"' '/AST_BUILDOPT_SUM/ {print $$2}' \
	  include/asterisk/buildopts.h); \
	  if [ "$$abi_hash" != "$(SAVED_ABI_HASH)" ]; then \
	    echo "Debian packaging problem: ABI checksum changed."; \
	    echo "  Was: $(SAVED_ABI_HASH)"; \
	    echo "  Now: $$abi_hash"; \
	    echo "Check include/asterisk/buildopts.h"; \
	    [ -n "$(EXP_RELEASE)" ] || exit 1; \
	  fi

SND_FILE=asterisk-core-sounds-en-gsm-1.4.20.tar.gz
execute_before_dh_clean:
	[ ! -r sounds/$(SND_FILE) ] || mv sounds/$($SND_FILE) debian/
	GREP=grep AWK=awk $(MAKE) distclean
	[ ! -r debian/$(SND_FILE) ] || mv debian/$(SND_FILE) sounds/

	[ ! -f .version.debian_sav ] || mv .version.debian_sav .version
	[ ! -f configure.debian_sav ] || mv configure.debian_sav configure
	[ ! -f third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav ] \
	  || mv third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5.debian_sav \
	  third-party/pjproject/pjproject-${PJVER}.tar.bz2.md5

override_dh_gencontrol:
	AST_BUILDOPT_SUM=$$(grep AST_BUILDOPT_SUM include/asterisk/buildopts.h  \
		| sed -e 's/.\+ "\(.\+\)\"/\1/g'); \
		dh_gencontrol -- -Vasterisk:ABI=$$AST_BUILDOPT_SUM

REMOVED_PROTO_CONFS = dundi mgcp skinny unistim
REMOVED_PROTO_FILES = $(REMOVED_PROTO_CONFS:%=debian/tmp/etc/asterisk/%.conf)
SUBPACKS_EXTRA = ooh323 mysql mp3
ifeq (linux,$(DEB_BUILD_ARCH_OS))
SUBPACKS_EXTRA += dahdi mobile tests
endif
SUBPACKS_EXTRA_DIRS = $(SUBPACKS_EXTRA:%=debian/asterisk-%)
SUBPACKS_EXTRA_DIRS_MOD = $(SUBPACKS_EXTRA_DIRS:%=%/usr/lib/$(DEB_HOST_MULTIARCH)/asterisk/modules)

override_dh_auto_install:
	$(FETCH_ENV) dh_auto_install -- $(BUILDFLAGS) -j1 config samples install-headers

execute_after_dh_auto_install:
	cp -a configs debian/tmp/usr/share/asterisk/conf
	$(RM) -f $(REMOVED_PROTO_FILES)
	mkdir -p debian/tmp/usr/bin/
	mkdir -p debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/dahdi/span_config.d
	cp -a debian/asterisk-config-custom debian/tmp/usr/bin/
	cp -a debian/asterisk-config-custom.1 debian/tmp/usr/share/man/man1/
	cp -a debian/50-asterisk debian/tmp/usr/share/dahdi/span_config.d/
	mkdir -p debian/tmp/$(deb_systemdsystemunitdir)
	test "$(deb_systemdsystemunitdir)" != "lib/systemd/system" && mv debian/tmp/lib/systemd/system/* debian/tmp/$(deb_systemdsystemunitdir)/ || true
	rmdir --ignore-fail-on-non-empty --parents debian/tmp/lib/systemd/system
	$(RM) -f debian/tmp/usr/sbin/conf2ael
	$(RM) -f debian/tmp/usr/sbin/muted
	$(RM) -f debian/tmp/usr/sbin/streamplayer
	$(RM) -f debian/tmp/usr/sbin/stereorize
	$(RM) -f debian/tmp/usr/sbin/hashtest*
	$(RM) -f debian/tmp/usr/sbin/refcounter

execute_after_dh_install-arch:
	extra_packs=$$(find $(SUBPACKS_EXTRA_DIRS_MOD) -name '*.so' -printf '%f\n');\
	  cd debian/asterisk-modules/usr/lib/$(DEB_HOST_MULTIARCH)/asterisk/modules \
	  && rm -f $$extra_packs

override_dh_installdocs:
	dh_installdocs --all -- $(DOCS)

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --uscan

opts=\
repacksuffix=~dfsg,\
pgpmode=auto,\
uversionmangle=s/\d\K-(rc)/~~$1/,\
dversionmangle=auto \
https://downloads.asterisk.org/pub/telephony/asterisk/releases/ \
asterisk-(20(?:\.\d+)+(?:-rc\d)?)@ARCHIVE_EXT@ group

opts=\
component=Xamr,\
mode=git,pgpmode=none,pretty=4.0.%cd,\
dversionmangle=auto \
https://github.com/traud/asterisk-amr.git \
HEAD checksum

opts=\
component=Xmp3,\
mode=svn,pgpmode=none,\
uversionmangle=s/~svn/./,\
dversionmangle=auto \
https://svn.digium.com/svn/thirdparty/mp3/trunk/ \
HEAD checksum

opts=\
component=Xopus,\
mode=git,pgpmode=none,pretty=0.0.%cd,\
dversionmangle=auto \
https://github.com/traud/asterisk-opus.git \
HEAD checksum

opts=\
component=Xpjproject,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-Xpjproject-$1/,\
dversionmangle=auto \
https://github.com/pjsip/pjproject/tags \
.*?(2\.13\.1)@ARCHIVE_EXT@ checksum
